<script lang="ts">
    import { Meta, Template, Story } from '@storybook/addon-svelte-csf'
    import Form from './Form.svelte'

    const commonsSelectArgs = {
        type: 'select',
        options: [
            { label: 'Item1', value: 'value1' },
            { label: 'Item2', value: 'value2' },
            { label: 'Item3', value: 'value3' },
            { label: 'Item4', value: 'value4' },
        ]
    }

    let calculatorItems = [
        {
            type: 'input',
            required: true,
            placeholder: 'first number'
        },
        {
            type: 'select',
            value: '+',
            options: [
                { label: '+', value: '+' },
                { label: '-', value: '-' },
                { label: '/', value: '/' },
                { label: 'x', value: '*' },
            ]
        },
        {
            type: 'input',
            required: true,
            placeholder: 'second number'
        },
    ]

    let calculatedValue
    function calculateValue(ev) {
        const items = ev.detail.items
        try {
            calculatedValue =  eval(`
                ${items[0].value}
                ${items[1].value}
                ${items[2].value}
            `)
        } catch(e) {
            calculatedValue = e.message
        }
    }

    let formFunctionEl
</script>

<Meta
    title="Components/Form"
    component={ Form }
    argTypes={{
        onChange: { 
            action: 'onChange',
        },
        change: {
            description: 'fired every change in any form item',
            table: {
                category: 'events',
                type: { 
                    summary: 'function', 
                },
            }
        },
        getData: {
            description: 'call to get form data as object or formdata',
            table: {
                category: 'functions',
                type: { 
                    summary: 'function', 
                },
            }
        }
    }}
/>

<!-- Default template -->
<Template let:args>
    <Form {...args} on:change={args.onChange}/>
</Template>

<Story
    name="Input"
    args={{
        items: [
            {
                type: 'input',
                required: true,
                name: 'commonInput',
                placeholder: 'my-input-placeholder-value'
            }
        ]
    }}
/>

<Story
    name="SelectNotSelected"
    storyName="Select not selected"
    args={{
        items: [{
            ...commonsSelectArgs,
            name: 'selecWithoutSelected',
        }]
    }}
/>

<Story
    name="SelectSelected"
    storyName="Select selected"
    args={{
        items: [{
            ...commonsSelectArgs,
            name: 'selecWithSelected',
            value: 'value4',
        }]
    }}
/>

<Story
    name="CalculatorExample"
    storyName="Calculator Example"
>
    <Form items={calculatorItems} on:change={ calculateValue }/>
    <br>
    <span>Result: { calculatedValue }</span>
</Story>

<Story
    name="GetFunction"
    storyName="Function to get data"
    description="Shows how to get data calling a function. You can call this function at any moment"
>
    <Form
        bind:this={ formFunctionEl }
        items={[
            {
                type: 'input',
                required: true,
                name: 'my-input-name',
                placeholder: 'my-input-placeholder-value'
            },
            {
                ...commonsSelectArgs,
                name: 'my-select-name'
            }
        ]}
    />
    <button
        on:click={() => {
            console.log('object data', formFunctionEl.getData('object'))
            console.log('form data', formFunctionEl.getData('formdata'))
        }}
    >
        Click me
    </button>
    <span>and look the return at the console</span>
</Story>